/**
 * Tencent is pleased to support the open source community by making Tars available.
 *
 * Copyright (C) 2016 THL A29 Limited, a Tencent company. All rights reserved.
 *
 * Licensed under the BSD 3-Clause License (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * https://opensource.org/licenses/BSD-3-Clause
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 */
// **********************************************************************
// This file was generated by a TARS parser!
// TARS version 1.0.1.
// **********************************************************************

package com.qq.tars.support.log.prx;

import com.qq.tars.protocol.annotation.*;
import com.qq.tars.protocol.tars.annotation.*;
import com.qq.tars.common.support.Holder;

@Servant
public interface LogPrx {
	/**
	 * 记录远程日志
	 * @param app, 应用名称
	 * @param server, 服务名称
	 * @param file, 文件名称
	 * @param format, 日志时间格式(%Y%m%d)
	 * @param buffer, 日志内容
	 */
	public void logger(String app, String server, String file, String format, java.util.List<String> buffer);
	/**
	 * 记录远程日志
	 * @param app, 应用名称
	 * @param server, 服务名称
	 * @param file, 文件名称
	 * @param format, 日志时间格式(%Y%m%d)
	 * @param buffer, 日志内容
	 */
	public void logger(String app, String server, String file, String format, java.util.List<String> buffer, @TarsContext java.util.Map<String, String> ctx);
	/**
	 * 记录远程日志
	 * @param app, 应用名称
	 * @param server, 服务名称
	 * @param file, 文件名称
	 * @param format, 日志时间格式(%Y%m%d)
	 * @param buffer, 日志内容
	 */
	public void async_logger(@TarsCallback LogPrxCallback callback, String app, String server, String file, String format, java.util.List<String> buffer);
	/**
	 * 记录远程日志
	 * @param app, 应用名称
	 * @param server, 服务名称
	 * @param file, 文件名称
	 * @param format, 日志时间格式(%Y%m%d)
	 * @param buffer, 日志内容
	 */
	public void async_logger(@TarsCallback LogPrxCallback callback, String app, String server, String file, String format, java.util.List<String> buffer, @TarsContext java.util.Map<String, String> ctx);
	/**
	 * 记录远程日志
	 * @param info, LogInfo
	 * @param buffer, 日志内容
	 */
	public void loggerbyInfo(LogInfo info, java.util.List<String> buffer);
	/**
	 * 记录远程日志
	 * @param info, LogInfo
	 * @param buffer, 日志内容
	 */
	public void loggerbyInfo(LogInfo info, java.util.List<String> buffer, @TarsContext java.util.Map<String, String> ctx);
	/**
	 * 记录远程日志
	 * @param info, LogInfo
	 * @param buffer, 日志内容
	 */
	public void async_loggerbyInfo(@TarsCallback LogPrxCallback callback, LogInfo info, java.util.List<String> buffer);
	/**
	 * 记录远程日志
	 * @param info, LogInfo
	 * @param buffer, 日志内容
	 */
	public void async_loggerbyInfo(@TarsCallback LogPrxCallback callback, LogInfo info, java.util.List<String> buffer, @TarsContext java.util.Map<String, String> ctx);
}
